<?php if (!isset($GLOBALS['vbulletin']->db)) exit;

class vB_PaidSubscriptionMethod_parspal extends vB_PaidSubscriptionMethod
{
	var $supports_recurring = false;
	var $display_feedback = true;

	function verify_payment()
	{
		$this->registry->input->clean_array_gpc('r', array('item' => TYPE_STR, 'receipt_number' => TYPE_STR));
		if (!extension_loaded('curl'))
		{
			$this->error = 'CURL is not enabled';
			return false;
		}
		if (!$this->test())
		{
			$this->error = 'Payment processor not configured';
			return false;
		}
		$this->transaction_id = $this->registry->GPC['receipt_number'];
		if(!empty($this->registry->GPC['item']) && !empty($this->registry->GPC['receipt_number']))
		{
			$this->paymentinfo = $this->registry->db->query_first("SELECT paymentinfo.*, user.username FROM " . TABLE_PREFIX . "paymentinfo AS paymentinfo INNER JOIN " . TABLE_PREFIX . "user AS user USING (userid) WHERE hash = '" . $this->registry->db->escape_string($this->registry->GPC['item']) . "'");
			if (!empty($this->paymentinfo))
			{
				$receipt_number = $this->registry->GPC['receipt_number'];
				$sub = $this->registry->db->query_first("SELECT * FROM " . TABLE_PREFIX . "subscription WHERE subscriptionid = " . $this->paymentinfo['subscriptionid']);
				$cost = unserialize($sub['cost']);
				$amount = floor($cost[0][cost][usd]*$this->settings['d2t']);
				require_once(dirname(__FILE__) . '/parspal_payment_helper.class.php');
				$p = new ParsPal_Payment_Helper($this->settings['apiKey']);
				$r = $p->paymentVerify($_POST, intval(ceil($amount)));
				if ($r)
				{
					$this->paymentinfo['currency'] = 'usd';
					$this->paymentinfo['amount'] = $cost[0][cost][usd];
					$this->type = 1;
					return true;
				}
				else
				{
					$this->error = $p->error;
					return false;
				}
			}
		}
		$this->error = 'Transaction Not Found!';
		return false;
	}

	function test()
	{
		if(!empty($this->settings['apiKey']) && !empty($this->settings['d2t']))
		{
			return true;
		}
		return false;
	}

	function generate_form_html($hash, $cost, $currency, $subinfo, $userinfo, $timeinfo)
	{
		global $vbphrase, $vbulletin, $show;
		$item = $hash;
		$cost = floor($cost*$this->settings['d2t']);
		$apiKey = $this->settings['apiKey'];
		$form['action'] = 'parspal.php';
		$form['method'] = 'POST';
		$settings =& $this->settings;
		$templater = vB_Template::create('subscription_payment_parspal');
		$templater->register('apiKey', $apiKey);
		$templater->register('cost', $cost);
		$templater->register('item', $item);
		$templater->register('subinfo', $subinfo);
		$templater->register('settings', $settings);
		$templater->register('userinfo', $userinfo);
		$form['hiddenfields'] .= $templater->render();
		return $form;
	}
}

?>